class GeogInstance < ActiveRecord::Base

  has_many :boundaries
  has_many :raster_categories
  has_many :raster_statistics
  has_many :raster_category_statistics
  has_many :area_data_statistics

  belongs_to :sample_geog_level
  belongs_to :terrapop_sample

  belongs_to :parent, :class_name => "GeogInstance", :foreign_key => "parent_id"
  has_many :children, :class_name => "GeogInstance", :foreign_key => "parent_id"

  def to_s
    label.nil? ? "<not set>" : label + "(#{code})"
  end
end
