require 'ipumsi_user_database'

class IpumsUser < IpumsiUserActiveRecord::Base
  self.table_name = :users

  validates :first_name, :last_name, :salt, :crypted_password, presence: true
  validates :email, uniqueness: true, format: {with: /\A[^@]+@[^@]+\.[^@]+\z/}


  def get_ipumsi_registration
    IpumsRegistration.find_by(id: self.id)
  end


end
