class RequestSample < ActiveRecord::Base
  belongs_to :sample
  belongs_to :extract_request

  after_initialize  :init_callback
  
  def custom_person_frequency
    self.sample.p_records / self.custom_sampling_ratio
  end

  def custom_household_frequency
    self.sample.h_records / self.custom_sampling_ratio
  end

  def custom_percent_density
    self.sample.density / self.custom_sampling_ratio
  end

  #compute random first hh to sample
  def generate_first_household_sampled

    # max_household is equal to ceiling(custom_sampling_ratio)
    max_household = custom_sampling_ratio.ceil

    # first_household-sampled should be at least 1 but no greater than the max_household
    self.first_household_sampled = rand(max_household) + 1;
  end

  private
  def init_callback
    self.custom_sampling_ratio = 1.0
  end
  
end
