class TerrapopExtractInformation
  include ExtractEngine::FileManagement
  
  def initialize(request)
    @request = request
  end
  
  def build_information_file
    create_directories(request)
    
    File.open(filename, "w") {|f|
      f.puts "User: " + request.user.firstname_lastname + " (" + request.user.email + ")"
      
      begin
        f.puts "TP Build: " + Rails.configuration.build_number
      rescue Exception => e
        $stderr.puts "*** Unable to determine build number for deployment"
      end
        
        
      f.puts "Extract Date: " + request.updated_at.strftime("%B %e, %Y - %H:%M:%S %Z")

      t = request.total_time.to_i
      
      ss, ms = t.divmod(1000)          #=> [270921, 0]
      mm, ss = ss.divmod(60)           #=> [4515, 21]
      hh, mm = mm.divmod(60)           #=> [75, 15]
      dd, hh = hh.divmod(24)           #=> [3, 3]
      #puts "%d days, %d hours, %d minutes and %d seconds" % [dd, hh, mm, ss]
      
      total_time = ""
      
      times = ActiveSupport::OrderedHash.new
      
      #times = {"day" => dd, "hour" => hh, "min" => mm, "sec" => ss, "ms" => ms}
      
      times[:day]  = dd
      times[:hour] = hh
      times[:min]  = mm
      times[:sec]  = ss
      #times[:ms]   = ms
      
      time_str = times.map{|key,amt|
        if amt > 0
          "#{amt} #{key.to_s}"
        end
      }.reject{|f| f.nil? }.join(", ")
      
      f.puts "Extract Time: " + time_str

    }
    
    filename
  end
  
  def filename
    File.join(request.location, request.name + "_info.txt")
  end
  
  def request
    @request
  end
  
end