class CreateGeogInstances < ActiveRecord::Migration
  def change
    
    create_table :geog_instances do |t|
      t.column      :sample_geog_level_id,  :bigint
      t.column      :parent_id,             :bigint
      t.column      :label,                 :string
      t.column      :code,                  :decimal, :precision => 20, :scale => 0
      t.column      :shape_area,            :decimal
      t.column      :notes,                 :text
      t.column      :boundary_id,           :bigint
      t.timestamps
    end
    
    foreign_key_raw(:geog_instances, :parent_id, :geog_instances, :id)
    foreign_key(:geog_instances, :sample_geog_level_id)
    foreign_key(:geog_instances, :boundary_id)

  end
end
