class CreateRasterGroups < ActiveRecord::Migration
  def change
    
    create_table :raster_groups do |t|
      t.column      :name,          :string
      t.column      :mnemonic,      :string, :limit => 64
      t.column      :display_order, :integer
      t.column      :parent_id,     :bigint
      t.column      :hidden,        :boolean
      t.timestamps
    end
    
    foreign_key_raw(:raster_groups, :parent_id, :raster_groups, :id)
    
    add_index :raster_groups, :parent_id
    add_index :raster_groups, :name
    add_index :raster_groups, :display_order
    
  end
end
