class CreateRasterCategoryStatistics < ActiveRecord::Migration
  def change
    
    create_table :raster_category_statistics do |t|
      t.column      :geog_instance_id,   :bigint
      t.column      :raster_variable_id, :bigint
      t.column      :raster_category_id, :bigint
      t.column      :code,               :bigint
      t.column      :total_count,        :bigint
      t.timestamps
    end
    
    add_index :raster_category_statistics, :geog_instance_id
    add_index :raster_category_statistics, :raster_variable_id
    add_index :raster_category_statistics, :raster_category_id
    
    foreign_key :raster_category_statistics, :geog_instance_id
    foreign_key :raster_category_statistics, :raster_variable_id
    foreign_key :raster_category_statistics, :raster_category_id
    
  end
end
