class CreateCacheItems < ActiveRecord::Migration
  
  def up
    connection = ActiveSupport::Cache::ActiveRecordStore::CacheItem.connection
    connection.create_table :cache_items do |t|
      t.string :key
      t.text :value
      t.text :meta_info
      t.datetime :expires_at
      t.datetime :created_at
      t.datetime :updated_at
    end

    connection.add_index :cache_items, :key, :unique => true
    connection.add_index :cache_items, :expires_at
    connection.add_index :cache_items, :updated_at
  end

  def down
    ActiveSupport::Cache::ActiveRecordStore::CacheItem.connection.drop_table :cache_items
  end
  
end
